/* extract the hid's from the conf file */

#include <stdio.h>
#include <stdlib.h>

#include "yaunc.h"

int
read_conf (void)
{
	FILE *fd;
	char key[MAXLINE], val[MAXLINE];
	char buffer[MAXLINE];
   
	/* open the conf file */
	if ( (fd = fopen(GetConfFilePath(), "r")) == NULL)
		err_log_sys("%s: Failed to open the config file", NAME);

	/* read mr. file, line by line */
	while (fgets(buffer, MAXLINE, fd)) {
		/* skip comments */
		if (buffer[0] != '#') {
			sscanf(buffer, "%s %s", key, val);
		/* possible key value arrangements in the conf file */
			if ( strcmp("auth", key) == 0 )
				SetAuth(strdup(val));
			else if (strcmp("delay", key) == 0)
				SetDelay(atoi(val));
			else if (strcmp("daemon", key) == 0)
				SetDaemonFlag(atoi(val));
			else
				err_log_msg("%s: %s is an invalid key\n", NAME, key);
		} 		/* if */
	} 			/* while */

	/* some simple sanity checks */
	if (GetDelay() < MIN_DELAY) {
		err_log_msg("%s: delay %d too low, minimum set to %d", NAME, GetDelay(), MIN_DELAY);
		SetDelay(MIN_DELAY);
	}	
	else if (GetDelay() > MAX_DELAY) {
		err_log_msg("%s: delay %d too high, max set to %d", NAME, GetDelay(), MAX_DELAY);
		SetDelay(MAX_DELAY);
	}	

	/* clean up */
	if (fclose(fd) != 0)
			err_log_ret("%s: fclose(%s) error.", NAME, GetConfFilePath());
	
	return 0;
}
